  //  lfo1  =============================
    if (midiChange(LFO1_SHAPE)){
      int shape = midivals[LFO1_SHAPE] % 6;
      
      float xSpeed = midivals[LFO1_SPEED] * inc;
      xSpeed = pow(100, (xSpeed - 1));
      float lfo1speed = (MAX_LFO_SPEED * xSpeed);
        
      switch(shape){
      
        case _WAVEFORM_SINE:
          waveform1.begin(1.0, lfo1speed, WAVEFORM_SINE);
          sendmessage("LFO1 Sine:",lfo1speed);
        break;
  
        case _WAVEFORM_SAWTOOTH:
          waveform1.begin(1.0, lfo1speed, WAVEFORM_SAWTOOTH);
          sendmessage("LFO1 Saw:",lfo1speed);
        break;
  
        case _WAVEFORM_SAWTOOTH_REVERSE:
          waveform1.begin(1.0, lfo1speed, WAVEFORM_SAWTOOTH_REVERSE);
          sendmessage("LFO1 Saw Rev:",lfo1speed);
        break;
  
        case _WAVEFORM_PULSE:
          waveform1.begin(1.0, lfo1speed, WAVEFORM_PULSE);
          sendmessage("LFO1 Pulse:",lfo1speed);
        break;
  
        case _WAVEFORM_TRIANGLE_VARIABLE:
          waveform1.begin(1.0, lfo1speed, WAVEFORM_TRIANGLE_VARIABLE);
          sendmessage("LFO1 Triangle:",lfo1speed);
        break;
  
        case _WAVEFORM_SAMPLE_HOLD:
          waveform1.begin(1.0, lfo1speed, WAVEFORM_SAMPLE_HOLD);
          sendmessage("LFO1 S/H:",lfo1speed);
        break;
      }        
    }

    if (midiChange(LFO1_SPEED)){
      float xSpeed = midivals[LFO1_SPEED] * inc;
      xSpeed = pow(100, (xSpeed - 1));
      float lfo1speed = (MAX_LFO_SPEED * xSpeed);
      waveform1.frequency(lfo1speed);
      sendmessage("LFO1 Hz:",lfo1speed);
    }
    if (midiChange(LFO1_PULSEWIDTH)){
      waveform1.pulseWidth(midivals[LFO1_PULSEWIDTH]/2);
      sendmessage("LFO1 Pw:",(float)midivals[LFO1_PULSEWIDTH]/2);
    }
    if (midiChange(LFO1_PHASE)){
      waveform1.phase((float)midivals[LFO1_PHASE] * inc * MAX_LFO_PHASE);
      sendmessage("LFO1 Phase:",(float)midivals[LFO1_PHASE] * inc * MAX_LFO_PHASE);
    }
    
  //  lfo2  =============================
    if (midiChange(LFO2_SHAPE)){
      int shape = midivals[LFO2_SHAPE] % 6;

      float xSpeed = midivals[LFO2_SPEED] * inc;
      xSpeed = pow(100, (xSpeed - 1));
      float lfo2speed = (MAX_LFO_SPEED * xSpeed);
        
      switch(shape){
      
        case _WAVEFORM_SINE:
          waveform2.begin(1.0, lfo2speed, WAVEFORM_SINE);
          sendmessage("LFO2 Sine:",lfo2speed);
        break;
  
        case _WAVEFORM_SAWTOOTH:
          waveform2.begin(1.0, lfo2speed, WAVEFORM_SAWTOOTH);
          sendmessage("LFO2 Saw:",lfo2speed);
        break;
  
        case _WAVEFORM_SAWTOOTH_REVERSE:
          waveform2.begin(1.0, lfo2speed, WAVEFORM_SAWTOOTH_REVERSE);
          sendmessage("LFO2 Saw Rev:",lfo2speed);
        break;
  
        case _WAVEFORM_PULSE:
          waveform2.begin(1.0, lfo2speed, WAVEFORM_PULSE);
          sendmessage("LFO2 Pulse:",lfo2speed);
        break;
  
        case _WAVEFORM_TRIANGLE_VARIABLE:
          waveform2.begin(1.0, lfo2speed, WAVEFORM_TRIANGLE_VARIABLE);
          sendmessage("LFO2 Triangle:",lfo2speed);
        break;
  
        case _WAVEFORM_SAMPLE_HOLD:
          waveform2.begin(1.0, lfo2speed, WAVEFORM_SAMPLE_HOLD);
          sendmessage("LFO2 S/H:",lfo2speed);
        break;
      }        
    }
    if (midiChange(LFO2_SPEED)){
      float xSpeed = midivals[LFO2_SPEED] * inc;
      xSpeed = pow(100, (xSpeed - 1));
      float lfo2speed = (MAX_LFO_SPEED * xSpeed);
      waveform2.frequency(lfo2speed);
      sendmessage("LFO2 Hz:",lfo2speed);
    }
    if (midiChange(LFO2_PULSEWIDTH)){
      waveform2.pulseWidth(midivals[LFO2_PULSEWIDTH]/2);
      sendmessage("LFO2 Pw:",(float)midivals[LFO2_PULSEWIDTH]/2);
    }
    if (midiChange(LFO2_PHASE)){
      waveform2.phase((float)midivals[LFO2_PHASE] * inc * MAX_LFO_PHASE);
      sendmessage("LFO2 Phase:",(float)midivals[LFO2_PHASE] * inc * MAX_LFO_PHASE);
    }
    
     
  //  lfo3  =============================
    if (midiChange(LFO3_SHAPE)){
      int shape = midivals[LFO3_SHAPE] % 6;

      float xSpeed = midivals[LFO3_SPEED] * inc;
      xSpeed = pow(100, (xSpeed - 1));
      float lfo3speed = (MAX_LFO_SPEED * xSpeed);
        
      switch(shape){
      
        case _WAVEFORM_SINE:
          waveformMod3.begin(1.0, lfo3speed, WAVEFORM_SINE);
          sendmessage("LFO3 Sine:",lfo3speed);
        break;
  
        case _WAVEFORM_SAWTOOTH:
          waveformMod3.begin(1.0, lfo3speed, WAVEFORM_SAWTOOTH);
          sendmessage("LFO3 Saw:",lfo3speed);
        break;
  
        case _WAVEFORM_SAWTOOTH_REVERSE:
          waveformMod3.begin(1.0, lfo3speed, WAVEFORM_SAWTOOTH_REVERSE);
          sendmessage("LFO3 Saw Rev:",lfo3speed);
        break;
  
        case _WAVEFORM_PULSE:
          waveformMod3.begin(1.0, lfo3speed, WAVEFORM_PULSE);
          sendmessage("LFO3 Pulse:",lfo3speed);
        break;
  
        case _WAVEFORM_TRIANGLE_VARIABLE:
          waveformMod3.begin(1.0, lfo3speed, WAVEFORM_TRIANGLE_VARIABLE);
          sendmessage("LFO3 Triangle:",lfo3speed);
        break;
  
        case _WAVEFORM_SAMPLE_HOLD:
          waveformMod3.begin(1.0, lfo3speed, WAVEFORM_SAMPLE_HOLD);
          sendmessage("LFO3 S/H:",lfo3speed);
        break;
      }        
    }
    if (midiChange(LFO3_SPEED)){
      float xSpeed = midivals[LFO3_SPEED] * inc;
      xSpeed = pow(100, (xSpeed - 1));
      float lfo3speed = (MAX_LFO_SPEED * xSpeed);
      waveformMod3.frequency(lfo3speed);
      sendmessage("LFO3 Hz:",lfo3speed);
    }
    if (midiChange(LFO3_FM)){
      waveformMod3.frequencyModulation(midivals[LFO3_FM]/2);
      sendmessage("LFO3 Pw:",(float)midivals[LFO3_FM]/2);
    }
    if (midiChange(LFO3_PHASE)){
      waveformMod3.phaseModulation((float)midivals[LFO3_PHASE] * inc * MAX_LFO_PHASE);
      sendmessage("LFO3 Phase:",(float)midivals[LFO3_PHASE] * inc * MAX_LFO_PHASE);
    }
    
     
  //  osc1  =============================
    if (midiChange(OSC1_SHAPE)){
      int shape = midivals[OSC1_SHAPE] % 5;

      switch(shape){
      
        case _WAVEFORM_SINE:
          waveformMod1.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY]], WAVEFORM_SINE);
          sendmessage("VCO1 Sine:",noteFreqs[midivals[OSC1_FREQUENCY]]);
        break;
  
        case _WAVEFORM_SAWTOOTH:
          waveformMod1.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY]], WAVEFORM_SAWTOOTH);
          sendmessage("VCO1 Saw:",noteFreqs[midivals[OSC1_FREQUENCY]]);
        break;
  
        case _WAVEFORM_SAWTOOTH_REVERSE:
          waveformMod1.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY]], WAVEFORM_SAWTOOTH_REVERSE);
          sendmessage("VCO1 Saw Rev:",noteFreqs[midivals[OSC1_FREQUENCY]]);
        break;
  
        case _WAVEFORM_PULSE:
          waveformMod1.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY]], WAVEFORM_PULSE);
          sendmessage("VCO1 Pulse:",noteFreqs[midivals[OSC1_FREQUENCY]]);
        break;
  
        case _WAVEFORM_TRIANGLE_VARIABLE:
          waveformMod1.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY]], WAVEFORM_TRIANGLE_VARIABLE);
          sendmessage("VCO1 Triangle:",noteFreqs[midivals[OSC1_FREQUENCY]]);
        break;
      }        
    }
    if (midiChange(OSC1_FREQUENCY)){
      waveformMod1.frequency(noteFreqs[midivals[OSC1_FREQUENCY]]);
      waveformMod2.frequency(noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
      sendmessage("VCO1 Freq:",noteFreqs[midivals[OSC1_FREQUENCY]]);
    }
    if (midiChange(OSC1_SHAPEMOD)){
      dc3.amplitude((float)midivals[OSC1_SHAPEMOD] * inc);
      sendmessage("VCO1 Mod:",(float)midivals[OSC1_SHAPEMOD] * inc);
    }
    if (midiChange(OSC1_FREQMOD)){
      waveformMod1.frequencyModulation((float)midivals[OSC1_FREQMOD] * inc * MAX_OSC_TRACKING);
      sendmessage("VCO1 FM:",(float)midivals[OSC1_FREQMOD] * inc * MAX_OSC_TRACKING);
    }

  //  osc2  =============================
    if (midiChange(OSC2_SHAPE)){
      int shape = midivals[OSC2_SHAPE] % 5;
 
       switch(shape){
      
        case _WAVEFORM_SINE:
          waveformMod2.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]], WAVEFORM_SINE);
          sendmessage("VCO2 Sine:",noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
        break;
  
        case _WAVEFORM_SAWTOOTH:
          waveformMod2.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]], WAVEFORM_SAWTOOTH);
          sendmessage("VCO2 Saw:",noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
        break;
  
        case _WAVEFORM_SAWTOOTH_REVERSE:
          waveformMod2.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]], WAVEFORM_SAWTOOTH_REVERSE);
          sendmessage("VCO2 Saw Rev:",noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
        break;
  
        case _WAVEFORM_PULSE:
          waveformMod2.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]], WAVEFORM_PULSE);
          sendmessage("VCO2 Pulse:",noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
        break;
  
        case _WAVEFORM_TRIANGLE_VARIABLE:
          waveformMod2.begin(1.0, noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]], WAVEFORM_TRIANGLE_VARIABLE);
          sendmessage("VCO2 Triangle:",noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
        break;
      }        
    }
    if (midiChange(OSC2_FREQUENCY)){
      waveformMod2.frequency(noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
      sendmessage("VCO2 Freq:",noteFreqs[midivals[OSC1_FREQUENCY] + midivals[OSC2_FREQUENCY]]);
    }
    if (midiChange(OSC2_SHAPEMOD)){
      dc2.amplitude((float)midivals[OSC2_SHAPEMOD] * inc);
      sendmessage("VCO2 Mod:",(float)midivals[OSC2_SHAPEMOD] * inc);
    }
    if (midiChange(OSC2_FREQMOD)){
      waveformMod2.frequencyModulation((float)midivals[OSC2_FREQMOD] * inc * MAX_OSC_TRACKING);
      sendmessage("VCO2 FM:",(float)midivals[OSC2_FREQMOD] * inc * MAX_OSC_TRACKING);
    }
